// Robert Hatton
// Bubble Sort Program
// April 1, 2010

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>

#define SIZE 20

// These functions were obtained from the internet "Dreamincode"
void ClearConsoleToColors(int ForgC, int BackC);
void Gotoxy( int x, int y );
void SetColorAndBackground(int ForgC, int BackC);

void Gotoxy( int x, int y ){
	COORD coord;
	coord.X = x;
	coord.Y= y;
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), coord);
}
//This will clear the console while setting the forground and
//  background colors.
void ClearConsoleToColors(int ForgC, int BackC)
{
     WORD wColor = ((BackC & 0x0F) << 4) + (ForgC & 0x0F);
     //Get the handle to the current output buffer...
     HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
     //This is used to reset the carat/cursor to the top left.
     COORD coord = {0, 0};
     //A return value... indicating how many chars were written
     //   not used but we need to capture this since it will be
     //   written anyway (passing NULL causes an access violation).
     DWORD count;

     //This is a structure containing all of the console info
     // it is used here to find the size of the console.
     CONSOLE_SCREEN_BUFFER_INFO csbi;
     //Here we will set the current color
     SetConsoleTextAttribute(hStdOut, wColor);
     if(GetConsoleScreenBufferInfo(hStdOut, &csbi))
     {
          //This fills the buffer with a given character (in this case 32=space).
          FillConsoleOutputCharacter(hStdOut, (TCHAR) 32, csbi.dwSize.X * csbi.dwSize.Y, coord, &count);
          
          FillConsoleOutputAttribute(hStdOut, csbi.wAttributes, csbi.dwSize.X * csbi.dwSize.Y, coord, &count );
          //This will set our cursor position for the next print statement.
          SetConsoleCursorPosition(hStdOut, coord);
     }
     return;
}

//This will set the forground color for printing in a console window.
void SetColor(int ForgC)
{
     WORD wColor; 
     //We will need this handle to get the current background attribute
     HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
     CONSOLE_SCREEN_BUFFER_INFO csbi;
     
     //We use csbi for the wAttributes word.
     if(GetConsoleScreenBufferInfo(hStdOut, &csbi))
     {
        //Mask out all but the background attribute, and add in the forgournd color
          wColor = (csbi.wAttributes & 0xF0) + (ForgC & 0x0F);
          SetConsoleTextAttribute(hStdOut, wColor);     
     }
     return;
}
//This will set the forground and background color for printing in a console window.
void SetColorAndBackground(int ForgC, int BackC)
{
     WORD wColor = ((BackC & 0x0F) << 4) + (ForgC & 0x0F);; 
     SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), wColor);     
     return;
}

int main( void )
{
	int array1[SIZE] ;
	int *aptr;
	int i, hold, stop = 20, p, x, s = 1 ;
	int y = 1, order ;
	
	ClearConsoleToColors(10, 1);
	SetColorAndBackground(10, 1);

	printf( " Robert Hatton\n"
		" CIS 120-401\n"
		" Bubble Sorting 2\n"
		" April 17, 2010" );
		
	
	srand( time( NULL ));
	Gotoxy( 0, 4 );
// Print random numbers and store in array
	for( i = 0 ; i < SIZE ; i++ ){
		array1[i] = rand() % 1000 ;
		
		printf( "%40d\n", array1[i] );
	}
	Gotoxy( 2, 8 );
	printf( "Please choose sorting order:\n"
		"  1-Ascending. 2-Descending." );
	scanf( "%d", &order );
	

		// Bubble Sort
		for( p = 0 ; p < SIZE ; p++ ){
			for( i = 0 ; i < SIZE - y; i++ ){
				if( order == 1 ){
					if( array1[i] > array1[ i + 1 ] ){
						hold = array1[i];
						array1[ i ] = array1[ i + 1 ] ;
						array1[ i + 1 ] = hold ;				
					}
				}
				if( order == 2 ){
					if( array1[i] < array1[ i + 1 ] ){
						hold = array1[i];
						array1[ i ] = array1[ i + 1 ] ;
						array1[ i + 1 ] = hold ;				
					}
				}
		//Re-print array each iteration of sorting loop	in seperate column			
				for( x = 0 ; x < SIZE ; x++ ){
					Gotoxy( 50, x + 4 );
					printf( "* " );
					if( array1[x] == hold ){
						SetColor( 14 );
					}
					if( stop <= x ){
						SetColor( 12 );
					}
					printf( "%3d", array1[x] );
					SetColor( 10 );
					printf( " *" );
					
				}
					
				_sleep(300);// For visual effects
					
				Gotoxy( 15, 15 );
				if( s == 1 ){
					printf( "SORTING |" );	 // B
					s++;					  // U
				}							   // S	
				else if( s == 2 ){			    // Y	
						printf( "SORTING /" ); 
						s++;					  // B
					}							   // A
					else if( s == 3 ){			    // R
							printf( "SORTING \\" );  // S
							s = 1 ;
						}							
				}
			stop--;
			y++;
		}
				for( x = 0 ; x < SIZE ; x++ ){
					Gotoxy( 50, x + 4 );
					printf( "* " );
					if( array1[x] == hold ){
						SetColor( 14 );
					}
					if( stop <= x ){
						SetColor( 12 );
					}
					printf( "%3d", array1[x] );
					SetColor( 10 );
					printf( " *\n" );
					
				}
		Gotoxy( 15, 15 );
		printf( "SORTING   " );
		Gotoxy( 15, 16 );
		printf( "COMPLETE" );
		Gotoxy( 0, 24 );			
		getch();
	

	return 0;
}

