/* Find mean, mode, and var
   by Tommy Lu
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int v[50];

float generate(int);
void sort(int);
int findmode(int);
float findvar(float, int);

float generate(int n)
{
   int i;
   float sum = 0.0;

   for (i=0; i<n; i++)
   {
      v[i] = rand() % 11;
      printf("%d\n", v[i]);
      sum += v[i];
   }

   return(sum/n);
}

void sort(int n)
{
   int i, j, min, ind, temp;

   for (i=0; i<n-1; i++)
   {
      min = v[i];
      ind = i;
      for (j=i+1; j<n; j++)
      {
	 if (v[j] < min)
	 {
	    min = v[j];
	    ind = j;
	 }
      }
      temp = v[i];
      v[i] = v[ind];
      v[ind] = temp;
      printf("%d\n", v[i]);
   }
   printf("%d\n", v[n-1]);
}

int findmode(int n)
{
   int temp, oldmode, newmode, oldno = 0, newno, i;

   newmode = v[0];
   newno = 1;

   for (i=1; i<n-1; i++)
   {
      temp = v[i];
      if (temp == newmode)
	 newno++;
      else
      {
	 if (newno > oldno)
	 {
	    oldmode = newmode;
	    oldno = newno;
	 }
	 newmode = temp;
	 newno = 1;
      }
   }
   if (newno > oldno) oldmode = newmode;

   return(oldmode);
}

float findvar(float mean,int n)
{
   int i;
   float sum = 0.0;

   for (i=0; i<n; i++)
      sum += (v[i] - mean) * (v[i] - mean);

   //printf("sum is %6.1f\n", sum);
   return (sum/n);
}

void main(void)
{
   int n, mode;
   float mean, var;

   printf("Enter the size of the sample (no greater than 50) or 0 to exit: ");
   scanf("%d", &n);

   while (n > 0)
   {
      mean = generate(n);
      printf("mean is %4.1f\n", mean);
      sort(n);
      printf("median is %d\n", v[(n-1)/2]);
      mode = findmode(n);
      printf("mode is %d\n", mode);
      var = findvar(mean,n);
      printf("varance is %6.2f\n", var);
      printf("standard deviation is %4.1f\n", sqrt(var));

      printf("Enter the size of the sample (no greater than 50) or 0 to exit: ");
      scanf("%d", &n);
   }
}
