/* calendar - version 4-0
   by Tommy Lu */

#include <stdio.h>
#include <conio.h>
#include <string.h>

int days[12];
char months[12][10];

int isleap(int);
int findprevious(int);
int findnext(int);
int firstday(int);
void get_month_names(void);
void get_days(int);
void main(void);

int isleap(int year)
{
   if (year > 0)
      if ((year % 4) != 0)
	 return(0);
      else
	 if ((year % 400) == 0)
	    return(1);
	 else
	    if ((year % 100) == 0)
	       return(0);
	    else
	       return(1);
   else
      return(0);
}

int findprevious(int day)
{
   return(day-1<0 ? 6 : day-1);
}

int findnext(int day)
{
   return(day+1>6 ? 0 : day+1);
}

int firstday(int year)
{
   int i, day = 3;

   if (year < 1997)
      for (i=1996; i>=year; i--)
      {
	 day = findprevious(day);
	 if (isleap(i)) day = findprevious(day);
      }
   else if (year > 1997)
      for (i=1997; i<year; i++)
      {
	 day = findnext(day);
	 if (isleap(i)) day = findnext(day);
      }
   return(day);
}

void get_month_names(void)
{
   strcpy(months[0],"January");
   strcpy(months[1],"February");
   strcpy(months[2],"March");
   strcpy(months[3],"April");
   strcpy(months[4],"May");
   strcpy(months[5],"June");
   strcpy(months[6],"July");
   strcpy(months[7],"August");
   strcpy(months[8],"September");
   strcpy(months[9],"October");
   strcpy(months[10],"November");
   strcpy(months[11],"December");
}

void get_days(int year)
{
   days[0] = 31;
   if (isleap(year))
      days[1] = 29;
   else
      days[1] = 28;
   days[2] = 31;
   days[3] = 30;
   days[4] = 31;
   days[5] = 30;
   days[6] = 31;
   days[7] = 31;
   days[8] = 30;
   days[9] = 31;
   days[10] = 30;
   days[11] = 31;
}

void main(void)
{
   char ans, ch;
   int  first[12], year, i, j, day, m;

   clrscr();
   get_month_names();
   printf("Enter year or 0 to exit: ");
   scanf("%d", &year);
   scanf("%c", &ch);
   while (year > 0)
   {
      get_days(year);
      day = firstday(year);
      first[0] = day;
      for (i=1; i<=11; i++)
      {
	 day = (day + days[i-1]) % 7;
	 first[i] = day;
      }
      for (m=1; m<=12; m++)
      {
	 printf("\t%s\n  S   M   T   W   R   F   S\n", months[m-1]);
	 for (j=0; j<=first[m-1]-1; j++) printf("    ");
	 for (i=1; i<=days[m-1]; i++)
	 {
	    if (j%7 == 0) printf("\n");
	    printf(" %2d ", i);
	    j++;
	 }
	 scanf("%c", &ch);
	 printf("\n\n");
      }
      printf("\nEnter year or 0 to exit: ");
      scanf("%d", &year);
      scanf("%c", &ch);
   }
}