/* Exercise 6.21 on p. 251 - airline reservation system using pointers
   by Tommy Lu
*/

#include <stdio.h>
#include <conio.h>

#define SIZE 10

int seatavailable(int [], int*, int);
int getseattype(void);
void assignseat(int [], int);
void boardingpass(int);

int seatavailable(int s[], int *i, int n)
{
	int avail=0, index;

	switch (n)
	{
	case 0:
		index = 0;
		while ((s[index] == 1) && (index <= 9))
			index++;
		if (index <= 9) avail = 1;
		break;
	case 1:
		index = 0;
		while ((s[index] == 1) && (index <= 4))
			index++;
		if (index <= 4)
		{
			avail = 1;
			*i = index;
		}
		break;
	case 2:
		index = 5;
		while ((s[index] == 1) && (index <= 9))
			index++;
		if (index <= 9)
		{
			avail = 1;
			*i = index;
		}
		break;
	}

	return (avail);
}

int getseattype(void)
{
	int seattype;

	printf("Please type 1 for \"first class\"\n");
	printf("Please type 2 for \"economy\"\n");
	scanf("%d", &seattype);
	while ((seattype != 1) && (seattype != 2))
	{
		printf("Please type 1 for \"first class\"\n");
		printf("Please type 2 for \"economy\"\n");
		scanf("%d", &seattype);
	}

	return (seattype);
}

void assignseat(int s[], int i)
{
	s[i] = 1;
	boardingpass(i);
}

void boardingpass(int i)
{
	printf("*************************************************************************\n");
	printf("                            BOARDING PASS\n\n");
	printf("Welcome to Flight by Night.  Your seat number is %d.\n", i+1);
	printf("Please report to the gate 20 minutes before the departure ");
	printf("or your seat will be reassigned to others.\nThank for flying with us.\n");
	printf("*************************************************************************\n");
	printf("\n\n");
}

int main()
{
	int seat[SIZE]={0}, seattype, index=-1;
	char ans='y';

	while ((ans == 'y') || (ans == 'Y'))
	{
		if (seatavailable(seat,&index,0))
		{
			seattype = getseattype();
			if (seattype == 1)
			{
				if (seatavailable(seat,&index,1))
					assignseat(seat,index);
				else
				{
					printf("First class is full.  Would you like for economy seat? (Y/N): ");
					scanf(" %c", &ans);
					if ((ans == 'y') || (ans == 'Y'))
					{
						if (seatavailable(seat,&index,2)) assignseat(seat,index);
					}
					else
						printf("No more seat available.  Next flight leaves in 3 hours.\n");
				}
			}
			else
			{
				if (seatavailable(seat,&index,2))
					assignseat(seat,index);
				else
				{
					printf("Economy class is full.  Would you like for first class? (Y/N): ");
					scanf(" %c", &ans);
					if ((ans == 'y') || (ans == 'Y'))
					{
						if (seatavailable(seat,&index,1)) assignseat(seat,index);
					}
					else
						printf("No more seat available.  Next flight leaves in 3 hours.\n");
				}
			}
		}
		else
			printf("No more seat available.  Next flight leaves in 3 hours.\n");

		printf("Continue to make reservations? (Y/N): ");
		scanf(" %c", &ans);
	}

	return 0;
}
